"""Add transfer ownership mixin

Revision ID: c3818d6b449a
Revises: fa96f749a787
Create Date: 2024-08-19 09:18:04.721383

"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

import clowm.db.types

# revision identifiers, used by Alembic.
revision: str = "c3818d6b449a"
down_revision: str | None = "fa96f749a787"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("bucket", sa.Column("transfer_new_owner_id", clowm.db.types.SQLUUID(length=16), nullable=True))
    op.add_column("bucket", sa.Column("transfer_comment", sa.String(length=256), nullable=True))
    op.add_column("bucket", sa.Column("transfer_created_at", mysql.INTEGER(unsigned=True), nullable=True))
    op.add_column("bucket", sa.Column("last_transfer_timestamp", mysql.INTEGER(unsigned=True), nullable=True))
    op.create_foreign_key(None, "bucket", "user", ["transfer_new_owner_id"], ["uid"], ondelete="SET NULL")
    op.add_column("resource", sa.Column("transfer_new_owner_id", clowm.db.types.SQLUUID(length=16), nullable=True))
    op.add_column("resource", sa.Column("transfer_comment", sa.String(length=256), nullable=True))
    op.add_column("resource", sa.Column("transfer_created_at", mysql.INTEGER(unsigned=True), nullable=True))
    op.add_column("resource", sa.Column("last_transfer_timestamp", mysql.INTEGER(unsigned=True), nullable=True))
    op.create_foreign_key(None, "resource", "user", ["transfer_new_owner_id"], ["uid"], ondelete="SET NULL")
    op.add_column("resource_version", sa.Column("compressed_size", mysql.BIGINT(unsigned=True), nullable=False))
    op.add_column("workflow", sa.Column("transfer_new_owner_id", clowm.db.types.SQLUUID(length=16), nullable=True))
    op.add_column("workflow", sa.Column("transfer_comment", sa.String(length=256), nullable=True))
    op.add_column("workflow", sa.Column("transfer_created_at", mysql.INTEGER(unsigned=True), nullable=True))
    op.add_column("workflow", sa.Column("last_transfer_timestamp", mysql.INTEGER(unsigned=True), nullable=True))
    op.create_foreign_key(None, "workflow", "user", ["transfer_new_owner_id"], ["uid"], ondelete="SET NULL")
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("workflow_ibfk_2", "workflow", type_="foreignkey")
    op.drop_column("workflow", "last_transfer_timestamp")
    op.drop_column("workflow", "transfer_created_at")
    op.drop_column("workflow", "transfer_comment")
    op.drop_column("workflow", "transfer_new_owner_id")
    op.drop_column("resource_version", "compressed_size")
    op.drop_constraint("resource_ibfk_2", "resource", type_="foreignkey")
    op.drop_column("resource", "last_transfer_timestamp")
    op.drop_column("resource", "transfer_created_at")
    op.drop_column("resource", "transfer_comment")
    op.drop_column("resource", "transfer_new_owner_id")
    op.drop_constraint("bucket_ibfk_2", "bucket", type_="foreignkey")
    op.drop_column("bucket", "last_transfer_timestamp")
    op.drop_column("bucket", "transfer_created_at")
    op.drop_column("bucket", "transfer_comment")
    op.drop_column("bucket", "transfer_new_owner_id")
    # ### end Alembic commands ###
